; My bible about serial programming is the file serial19.doc in
; the docs directory of assembler snippets (1995) that can be
; found on simtelnet/msdos/asmutl directory.

; %include "macros.mac"
; %include "boot.mac"
%include "serial.mac"

;Because I don't know how to return value by the stack, I
; decided to get all globals fcnts use registers

; ToDo
; -fix bug in set_com_speed with speed>65535
; -add calls to tx_handler in do_tx if tx_nbr_cars<tx_trig_level
; -not just detect presence, detect the kind, also use this info
; -detect the Irq and use the information
; -lots of global fncts like set_parity,get_speed
; -add Fifos on 16550AN
; -make find_port less ugly
; -com0&1 badly hard-coded in Irq4&3

; extern print,putc,patch_int,print_hex

; This routine is from serial19.doc, still stuff to convert
;int detect_UART(unsigned baseaddr)
;{
;   // this function returns 0 if no UART is installed.
;   // 1: 8250, 2: 16450 or 8250 with scratch reg., 3: 16550, 4: 16550A
;   int x,olddata;
;   // check if a UART is present anyway
;   olddata=inp(baseaddr+4);
;   outp(baseaddr+4,0x10);
;   if ((inp(baseaddr+6)&0xf0)) return 0;
;   outp(baseaddr+4,0x1f);
;   if ((inp(baseaddr+6)&0xf0)!=0xf0) return 0;
;   outp(baseaddr+4,olddata);
;   // next thing to do is look for the scratch register
;   olddata=inp(baseaddr+7);
;   outp(baseaddr+7,0x55);
;   if (inp(baseaddr+7)!=0x55) return 1;
;   outp(baseaddr+7,0xAA);
;   if (inp(baseaddr+7)!=0xAA) return 1;
;   outp(baseaddr+7,olddata); // we don't need to restore it if it's not the
re
;   // then check if there's a FIFO
;   outp(baseaddr+2,1);
;   x=inp(baseaddr+2);
;   // some old-fashioned software relies on this!
;   outp(baseaddr+2,0x0);
;   if ((x&0x80)==0) return 2;
;   if ((x&0x40)==0) return 3;
;   return 4;
;}

; In: base address in cx, parameter is reg. offset  Out: al = value
%macro readUART 1
  push edx
  mov dx,cx
  add dx,%1
  in al,dx
  pop edx
  %endmacro

;  In: base addr in cx, param 1 is reg. offset, param 2 is byte value
%macro writeUART 2
  push edx
  mov dx,cx
  add dx,%1
  mov al,%2
  out dx,al
  pop edx
  %endmacro

SECTION .text

init_com:
    pusha
    ;callproc print, msg_init
    call init_base_addresses
    call check_all_ports
    call set_handlers
    call reset_uarts
    popa
    ret
	
; ====================================================================
; ===========  Globals fctns goes here ===============================
WRITE_COM_BYTE: ; (comport char -- )
    push ebx
    DPOP ebx
    DPOP eax
    push ebx
    call find_port
    pop ebx
    mov al,bl
    push eax
    mov bx,comstruct(tx_nbr_cars)
    pop eax
    cmp bx,SizeBuffer
    jge .buffer_full
    mov ebx,comstruct(tx_tail)
    mov [ebx],al
    inc word comstruct(tx_nbr_cars)
    ; Let's 'increment' tx_tail
    inc dword comstruct(tx_tail)
    mov eax,comstruct(tx_tail)
    mov ebx,esi
    add ebx,tx_buffer.end-base_address
    cmp eax,ebx
    jb .no_wrap
    mov eax,esi
    add eax,tx_buffer-base_address
    mov comstruct(tx_tail),eax
  .no_wrap:
    readUART IER
    or   al,2  ; set bit 1
    writeUART IER,al
    nop
    nop  ; give the UART some time to kick the interrupt...
    nop
    cli  ; make sure no interrupts get in-between if not already running
    readUART LSR
    test al,40h  ; is there a transmission running?
    jz .dont_crank  ; yes, so don't mess it up
    call do_tx  ; no, crank it up
  .dont_crank:
  .buffer_full:
  .end_test:
    sti
    pop ebx
    ret
eWRITE_COM_BYTE

READ_COM_BYTE: ;  (comport -- -1 if nothing to read | byte)
    push ebx
    DPOP eax
    call find_port
    mov ax,comstruct(rx_nbr_cars)
    or ax,ax
    jz .nothing
    ; Read it from the rx_buffer
      ; first, take the car at the head
      mov ebx,comstruct(rx_head)
      xor eax,eax
      mov al,[ebx]
      push eax
      dec word comstruct(rx_nbr_cars)
      ; Let's 'increment' rx_head
      inc dword comstruct(rx_head)
      mov eax,comstruct(rx_head)
      mov ebx,esi
      add ebx,rx_buffer.end-base_address
      cmp eax,ebx
      jb .no_wrap
      mov eax,esi
      add eax,rx_buffer-base_address
      mov comstruct(rx_head),eax
    .no_wrap:
      pop eax
      DPUSH eax
    jmp .end
  .nothing:
    DPUSH dword -1
  .end:
    pop ebx
    ret
eREAD_COM_BYTE

SET_COM_SPEED: ; (comport speed -- )
    push ebx
    DPOP ebx
    DPOP eax
    push ebx
    call find_port
    pop ebx
    mov eax,115200
    xor edx,edx
    div ebx ; now eax=quotient (I cares), edx=remaining (don't cares)
    push eax
    call set_DLAB
    pop eax
    writeUART DL_LOW,al
    shr eax,8
    writeUART DL_HI,al
    call reset_DLAB
    pop ebx
    ret
eSET_COM_SPEED

SET_COM_BITS: ; (comport nbr_bits -- )
    push ebx
    DPOP ebx
    DPOP eax
    push ebx
    call find_port
    pop ebx
    sub bl,5
    readUART LCR
    and al,11111100b
    or al,bl
    writeUART LCR,al
    pop ebx
    ret
eSET_COM_BITS

SEND_BREAK: ; (comport -- )
    push ebx
    DPOP eax
    call find_port
    readUART LCR
    or al,40h
    writeUART LCR,al
    push ecx
    mov ecx,10000000
  .wait:
    loop .wait
    pop ecx
    readUART LCR
    and al,10111111b
    writeUART LCR, al
    pop ebx
    ret
eSEND_BREAK


; In al=comport, ebx=address of the handler
SET_RX_HANDLER:
    push ebx
    call find_port
    pop ebx
    mov comstruct(handler_rx),ebx
    ret
eSET_RX_HANDLER

; In al=comport, ebx=address of the handler
SET_ERROR_HANDLER:
    push ebx
    call find_port
    pop ebx
    mov comstruct(handler_error),ebx
    ret
eSET_ERROR_HANDLER

GET_RTS_DTR:
    ; In al=comport Out: bl bit0=DTR bit1=RTS
    push eax
    call find_port
    readUART MCR
    mov bl,al
    pop eax
    ret
eGET_RTS_DTR

SET_DTR: ; (comport -- )
    push ebx
    push eax
    DPOP eax
    call find_port
    readUART MCR
    or al,1
    writeUART MCR,al
    pop eax
    pop ebx
    ret
eSET_DTR

SET_RTS: ; (comport -- )
    push ebx
    push eax
    DPOP eax
    call find_port
    readUART MCR
    or al,2
    writeUART MCR,al
    pop eax
    pop ebx
    ret
eSET_RTS

RESET_DTR: ; (comport -- )
    push ebx
    push eax
    DPOP eax
    call find_port
    readUART MCR
    and al,11111110b
    writeUART MCR,al
    pop eax
    pop ebx
    ret
eRESET_DTR

RESET_RTS: ; (comport -- )
    push ebx
    push eax
    DPOP eax
    call find_port
    readUART MCR
    and al,11111101b
    writeUART MCR,al
    pop eax
    pop ebx
    ret
eRESET_RTS

COM_DEBUG:
    ; in al=port
    call find_port
    xor eax,eax
    mov ax,comstruct(rx_nbr_cars)
    callproc print_hex,eax
    mov eax,comstruct(rx_head)
    callproc print_hex,eax
    mov eax,comstruct(rx_tail)
    callproc print_hex,eax
    ;cr
    xor eax,eax
    mov ax,comstruct(tx_nbr_cars)
    callproc print_hex,eax
    mov eax,comstruct(tx_head)
    callproc print_hex,eax
    mov eax,comstruct(tx_tail)
    callproc print_hex,eax
    cr
    ret
eCOM_DEBUG
; ===========  End of globals fctns ==================================

find_port:
    ; In al=0 1 2 or 3 (comport number)
    ; Out si is on the port and cx is the base io address of the port
    and al,3 ; just need 2 bits to choose among 4 ports
    cmp al,0
    jnz .not_0
    mov esi,com0
    jmp .normal_end
  .not_0:
    cmp al,1
    jnz .not_1
    mov esi,com1
    jmp .normal_end
  .not_1:
    cmp al,2
    jnz .not_2
    mov esi,com2
    jmp .normal_end
  .not_2:
    cmp al,3
    jnz .not_3
    mov esi,com3
    jmp .normal_end
  .not_3:
    jmp .end
  .normal_end:
    mov ax,[esi]
    mov cx,ax
  .end:
    ret

%macro init_base_add 1
    mov edi,com%1
    mov ax,comport%1
    stosw
    %endmacro

init_base_addresses:
    init_base_add 0
    init_base_add 1
    init_base_add 2
    init_base_add 3
    ret

check_uart_present:
    ; in cx=2e8 or 3f8 etc.
    ; out al (0=no uart, 1=uart present)
    readUART MCR
    mov bl,al ; save original MCR value there
    writeUART MCR,10h ; set loopback mode on so as to change normal meaning
   ; of MSR
    readUART MSR
    and al,0f0h
    jnz .no_uart
    writeUART MCR,1fh
    readUART MSR
    and al,0f0h
    cmp al,0f0h
    jnz .no_uart
    mov al,1
    jmp .end
  .no_uart mov al,0
    push ax
    writeUART MCR,bl
    pop ax
  .end ret

check_port:
  ; in esi=com0, com1, com2 or com3
  lodsw
  mov cx, ax
  call check_uart_present
  mov edi,esi
  stosb
  ret

test_port:
    call check_port
    or al,al
    jz .no
    callproc putc,'Y'
    jmp .end
  .no callproc putc,'N'
  .end:
;    cr
    ret

check_all_ports:
    ; This looks bright but what would be bright would be
    ; to actually use the informatin collected :-)
 ;   callproc print,autodetect_msg
    mov esi,com0
 ;   callproc print,com0str
    call test_port
    mov esi,com1
 ;   callproc print,com1str
    call test_port
    mov esi,com2
 ;   callproc print,com2str
    call test_port
    mov esi,com3
 ;   callproc print,com3str
    call test_port
    cr
    ret

set_handlers:
    ; IRQ 3 for comport1 and comport3
    callproc patch_int,     0x23, irq3_handler
    ; IRQ 4 for comport0 and comport2
    callproc patch_int,     0x24, irq4_handler
    ; let's enable them in interrupt mask
    in al,21h
    and al,11100111b
    out 21h,al
    ret

set_DLAB:
  ; IN: cx=base_address
    readUART LCR
    or al,80h
    writeUART LCR,al
    ret

reset_DLAB:
  ; IN: cx=base_address
    readUART LCR
    and al,7fh
    writeUART LCR,al
    ret

init_comport:
    xor eax,eax
    mov comstruct(rx_nbr_cars),ax
    mov comstruct(tx_nbr_cars),ax
    mov eax,esi
    add eax,(rx_buffer-base_address)
    mov comstruct(rx_head),eax
    mov comstruct(rx_tail),eax
    mov eax,esi
    add eax,(tx_buffer-base_address)
    mov comstruct(tx_head),eax
    mov comstruct(tx_tail),eax
    mov eax,do_nothing
    mov comstruct(handler_tx),eax
    mov comstruct(handler_rx),eax
    mov comstruct(handler_modem),eax
    mov comstruct(handler_error),eax
    ret

reset_uart:
    call init_comport
    mov cx,comstruct(base_address)
    ; deactivate interrupts the time we fool around
    call reset_DLAB
    writeUART IER,0
    ; Now, let's set 1200bps
    call set_DLAB
    writeUART DL_LOW, 60h
    writeUART DL_HI, 0
    ; set parity none, 8bits, 1stop, also reset DLAB
    writeUART LCR, 00000011b
    ; enable back interrupt on all kind of events
    writeUART IER,1111b
    ; let's clear RTS and DTR, give current to mouse, also enable interrupts

    writeUART MCR,00001011b
    ret

reset_uarts:
    mov esi,com0
    call reset_uart
    mov esi,com1
    call reset_uart
    mov esi,com2
    call reset_uart
    mov esi,com3
    call reset_uart
    ret

do_nothing: ; to initialize the high-level handlers
    ret

do_modem:
    readUART MSR
    ;callproc putc,'M'
    ret

do_tx:
    mov cx,comstruct(base_address) ; Make sure it is still valid
    mov ax,comstruct(tx_nbr_cars)
    or ax,ax
    jz .nothing_to_send

    ; Send the car at the head
    mov ebx,comstruct(tx_head)
    mov al,[ebx]
    writeUART THR, al

    dec word comstruct(tx_nbr_cars)

      ; Let's 'increment' tx_head
      inc dword comstruct(tx_head)
      mov eax,comstruct(tx_head)
      mov ebx,esi
      add ebx,tx_buffer.end-base_address
      cmp eax,ebx
      jb .no_wrap
      mov eax,esi
      add eax,tx_buffer-base_address
      mov comstruct(tx_head),eax
    .no_wrap:
    jmp .end
  .nothing_to_send:
    ; If nothing more to send, let's deactivate THRE interrupt
    readUART IER
    and al,11111101b
    writeUART IER,1101b
  .end:
    ret

do_rx:
    readUART RBR
    mov bx,comstruct(rx_nbr_cars)
    cmp bx,SizeBuffer
    jge .buffer_full
    mov ebx,comstruct(rx_tail)
    mov [ebx],al
    inc word comstruct(rx_nbr_cars)
    ; Let's 'increment' rx_tail
    inc dword comstruct(rx_tail)
    mov eax,comstruct(rx_tail)
    mov ebx,esi
    add ebx,rx_buffer.end-base_address
    cmp eax,ebx
    jb .no_wrap
    mov eax,esi
    add eax,rx_buffer-base_address
    mov comstruct(rx_tail),eax
  .no_wrap:
  .buffer_full:
    ; Most old UART considers that by reading IIR in dispatcher routine
    ; I acknoledge Tx interrupt, of course that's not what I want so
    ; I will test in LSR and call do_tx when needed
    readUART IER
    test al,2
    jz .end ; if Tx interrupt not even set, don't call do_tx
    readUART LSR
    and al,00100000b
    jz .end ; if THR not empty, don't call do_tx
    call do_tx
  .end:
    ;callproc putc,'R'
    ; Now, if rx_nbr_cars>=trig_level, call handler_rx
    mov ax,comstruct(rx_nbr_cars)
    cmp ax,comstruct(rx_trig_level)
    jb .do_ret
    mov eax,comstruct(handler_rx)
    call eax
  .do_ret:
    ret

do_error:
    readUART LSR
    mov ebx,comstruct(handler_error)
    call ebx
    ret

dispatcher:
    xor eax,eax
    readUART IIR
    and al,6
    shl eax,1
    add eax,dispatch
    mov eax,[eax]
    jmp eax

irq3_handler:
    pushad
    irqack 3
  .loop:
    mov esi,com1
    mov cx,comstruct(base_address)
    readUART IIR
    test al,1
    jnz .not_for_us
    call dispatcher
    jmp .loop
  .not_for_us:
    popad
    iret

irq4_handler:
    pushad
    irqack 4
  .loop:
    mov esi,com0
    mov cx,comstruct(base_address)
    readUART IIR
    test al,1
    jnz .not_for_us
    call dispatcher
    jmp .loop
  .not_for_us:
    popad
    iret

SECTION .data
msg_init db "++ Serial driver",10,0
autodetect_msg db "scanning comports 0 to 4 for hardware UART",10,0
com0str db " com0:",0
com1str db " com1:",0
com2str db " com2:",0
com3str db " com3:",0

dispatch dd do_modem,do_tx,do_rx,do_error

SECTION .bss

com0:
base_address     resw 1 ; base address
is_present       resb 1 ; is_present
Irq              resb 1 ; Irq
rx_nbr_cars      resw 1 ; rx_nbr_cars
rx_head          resd 1 ; rx_head
rx_tail          resd 1 ; rx_tail
rx_trig_level    resw 1 ; rx_trigger_level to call handler_rx
rx_buffer        resb SizeBuffer ; rx_buffer OTHER COMs MUST HAVE SAME VALUE!
.end
tx_nbr_cars      resw 1 ; tx_nbr_cars
tx_head          resd 1 ; tx_head
tx_tail          resd 1 ; tx_tail
tx_trig_level    resw 1 ; tx_trigger_level to call handler_tx
tx_buffer        resb SizeBuffer ; tx_buffer OTHER COMs MUST HAVE SAME VALUE!
.end
handler_rx       resd 1 ; HL (High-Level) handler for rx_trigger level reach
ed
handler_tx       resd 1 ; HL handler for tx_triger level reached
handler_modem    resd 1 ; HL handler for modem changed state
handler_error    resd 1 ; HL handler for error occured

com1 resw 1 ; base address
     resb 1 ; is_present
     resb 1 ; Irq
     resw 1 ; rx_nbr_cars
     resd 1 ; rx_head
     resd 1 ; rx_tail
     resw 1 ; rx_trigger_level
     resb SizeBuffer ; rx_buffer
     resw 1 ; tx_nbr_cars
     resd 1 ; tx_head
     resd 1 ; tx_tail
     resw 1 ; tx_trigger_level
     resb SizeBuffer ; tx_buffer
     resd 1 ; HL (High-Level) handler for rx_trigger level reached
     resd 1 ; HL handler for tx_triger level reached
     resd 1 ; HL handler for modem changed state
     resd 1 ; HL handler for error occured

com2 resw 1 ; base address
     resb 1 ; is_present
     resb 1 ; Irq
     resw 1 ; rx_nbr_cars
     resd 1 ; rx_head
     resd 1 ; rx_tail
     resw 1 ; rx_trigger_level
     resb SizeBuffer ; rx_buffer
     resw 1 ; tx_nbr_cars
     resd 1 ; tx_head
     resd 1 ; tx_tail
     resw 1 ; tx_trigger_level
     resb SizeBuffer ; tx_buffer
     resd 1 ; HL (High-Level) handler for rx_trigger level reached
     resd 1 ; HL handler for tx_triger level reached
     resd 1 ; HL handler for modem changed state
     resd 1 ; HL handler for error occured

com3 resw 1 ; base address
     resb 1 ; is_present
     resb 1 ; Irq
     resw 1 ; rx_nbr_cars
     resd 1 ; rx_head
     resd 1 ; rx_tail
     resw 1 ; rx_trigger_level
     resb SizeBuffer ; rx_buffer
     resw 1 ; tx_nbr_cars
     resd 1 ; tx_head
     resd 1 ; tx_tail
     resw 1 ; tx_trigger_level
     resb SizeBuffer ; tx_buffer
     resd 1 ; HL (High-Level) handler for rx_trigger level reached
     resd 1 ; HL handler for tx_triger level reached
     resd 1 ; HL handler for modem changed state
     resd 1 ; HL handler for error occured
